#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <clientprefs>
#include <sdkhooks>

#define DOD_PAINTBALL_VERSION      "1.3"

//#define PAINTBALL_DEBUG 1

#define MAX_FILE_LEN 80

 //1      =       Knife
 //2      =       Spade
 //3      =       Colt
 //4      =       P38
 //5      =       C96
 //6      =       Garand
 //7      =       M1 Carbine
 //8      =       Karabiner98
 //9      =       Springfield
//10      =       Karabiner98 Sniper
//11      =       Thompson
//12      =       MP40
//13      =       Sturmgewehr44 -full auto
//14      =       BAR -full auto
//15      =       30cal -deployed
//16      =       MG42 -deployed
//17      =       Bazooka
//18      =       PanzerSchreck
//19      =       FragGrenade
//20      =       StickGrenade
//21      =       FragGrenade -live
//22      =       StickGrenade -live
//23      =       SmokeGrenade US
//24      =       SmokeGrenade GER
//25      =       RifleGrenade US
//26      =       RifleGrenade GER
//27      =       RifleGrenade US -live
//28      =       RifleGrenade GER -live
//29      =       Punch Thompson
//30      =       Punch MP40
//31      =       Garand -iron sight
//32      =       Karabiner98 -iron sight
//33      =       Springfield -scoped
//34      =       Karabiner98 Sniper -scoped
//35      =       30cal -undeployed
//36      =       MG42 -undeployed
//37      =       BAR -semi auto
//38      =       StG44 -semi auto

public Plugin:myinfo = 
{
    name = "DOD Paintball",
    author = "Andi67",
    description = "Add paintball impacts on the map after shots.",
    version = DOD_PAINTBALL_VERSION,
    url = "www.dodsourceplugins.net"
}

new ColtIndex[512];
new ColtIndexCount = 0;
new P38Index[512];
new P38IndexCount = 0;
new C96Index[512];
new C96IndexCount = 0;
new GarandIndex[512];
new GarandIndexCount = 0;
new M1CarbineIndex[512];
new M1CarbineIndexCount = 0;
new SpringfieldIndex[512];
new SpringfieldIndexCount = 0;
new K98SniperIndex[512];
new K98SniperIndexCount = 0;
new ThompsonIndex[512];
new ThompsonIndexCount = 0;
new MP40Index[512];
new MP40IndexCount = 0;
new STGAutoIndex[512];
new STGAutoIndexCount = 0;
new BarAutoIndex[512];
new BarAutoIndexCount = 0;
new CalldeployedIndex[512];
new CalldeployedIndexCount = 0;
new MG42DeployedIndex[512];
new MG42DeployedIndexCount = 0;
new GarandIronSightIndex[512];
new GarandIronSightIndexCount = 0;
new K98IronSightIndex[512];
new K98IronSightIndexCount = 0;
new SpringfieldScopedIndex[512];
new SpringfieldScopedIndexCount = 0;
new K98SniperScopedIndex[512];
new K98SniperScopedIndexCount = 0;
new CallUndeployedIndex[512];
new CallUndeployedIndexCount = 0;
new MG42UndeployedIndex[512];
new MG42UndeployedIndexCount = 0;
new BarSemiAutoIndex[512];
new BarSemiAutoIndexCount = 0;
new STGSemiAutoIndex[512];
new STGSemiAutoIndexCount = 0;
new K98Index[512];
new K98IndexCount = 0;
new RocketIndex[512];
new RocketIndexCount = 0;
new GrenadeIndex[512];
new GrenadeIndexCount = 0;

new g_clientPrefs[MAXPLAYERS+1];

new g_clientsPaintballEnabled[MAXPLAYERS];
new g_clientsPaintballEnabledTotal = 0;

new Handle:g_Cvar_PrefDefault = INVALID_HANDLE;
new Handle:g_Cookie_Pref      = INVALID_HANDLE;
new Handle:g_Explosive = INVALID_HANDLE;
new Handle:g_Rocket = INVALID_HANDLE;
new Handle:g_Grenade = INVALID_HANDLE;

new g_Explosion;

static const String:g_szGrenadeTypes[][] =
{
	"grenade_smoke_us",
	"grenade_smoke_ger",
	"grenade_frag_us",
	"grenade_frag_ger",
	"grenade_riflegren_us",
	"grenade_riflegren_ger",
	"rocket_bazooka",
	"rocket_pschreck"
};

public OnPluginStart()
{
	LoadTranslations("dod_paintball.phrases");

	new Handle:Cvar_Version = CreateConVar("dod_paintball_version", DOD_PAINTBALL_VERSION, 
	"Dod Paintball Version.", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	// KLUGE: Update version cvar if plugin updated on map change.
	SetConVarString(Cvar_Version, DOD_PAINTBALL_VERSION);
	
	g_Explosive = CreateConVar("dod_paintball_explosive","1");
	g_Rocket = CreateConVar("dod_paintball_rocket","1");
	g_Grenade = CreateConVar("dod_paintball_grenade","1");

	g_Cvar_PrefDefault     = CreateConVar("dod_paintball_prefdefault", "1", 
	"Default setting for new users.");
	g_Cookie_Pref      = RegClientCookie("dod_paintball_pref", 
	"DOD Paintball pref", CookieAccess_Private);
	RegConsoleCmd("dod_paintball", MenuPaintball, "Show Dodpaintball settings menu.");
	HookEvent("dod_stats_weapon_attack", Event_DodStatsWeaponAttack);
}
    
public OnMapStart()
{
	#if defined PAINTBALL_DEBUG
	LogError("[PAINTBALL_DEBUG] OnMapStart()");
	#endif
	ColtIndexCount = 0;

	P38IndexCount = 0;

	C96IndexCount = 0;

	GarandIndexCount = 0;

	M1CarbineIndexCount = 0;

	SpringfieldIndexCount = 0;

	K98SniperIndexCount = 0;

	ThompsonIndexCount = 0;

	MP40IndexCount = 0;

	STGAutoIndexCount = 0;

	BarAutoIndexCount = 0;

	CalldeployedIndexCount = 0;

	MG42DeployedIndexCount = 0;

	GarandIronSightIndexCount = 0;

	K98IronSightIndexCount = 0;

	SpringfieldScopedIndexCount = 0;

	K98SniperScopedIndexCount = 0;

	CallUndeployedIndexCount = 0;

	MG42UndeployedIndexCount = 0;

	BarSemiAutoIndexCount = 0;

	STGSemiAutoIndexCount = 0;

	K98IndexCount = 0;

	RocketIndexCount = 0;

	GrenadeIndexCount = 0;
	
	// Load config file with colors
	new Handle:KvColt = CreateKeyValues("Colt");
	new Handle:KvP38 = CreateKeyValues("P38");
	new Handle:KvC96 = CreateKeyValues("C96");
	new Handle:KvGarand = CreateKeyValues("Garand");
	new Handle:KvM1Carbine = CreateKeyValues("M1Carbine");
	new Handle:KvSpringfield = CreateKeyValues("Springfield");
	new Handle:KvK98Sniper = CreateKeyValues("K98Sniper");
	new Handle:KvThompson = CreateKeyValues("Thompson");
	new Handle:KvMP40 = CreateKeyValues("MP40");
	new Handle:KvSTGAuto = CreateKeyValues("STG44Auto");
	new Handle:KvBarAuto = CreateKeyValues("BarAuto");
	new Handle:KvCalldeployed = CreateKeyValues("Calldeployed");
	new Handle:KvMG42Deployed = CreateKeyValues("MG42Deployed");
	new Handle:KvGarandIronSight = CreateKeyValues("GarandIronSight");
	new Handle:KvK98IronSight = CreateKeyValues("K98IronSight");
	new Handle:KvSpringfieldScoped = CreateKeyValues("SpringfieldScoped");
	new Handle:KvK98SniperScoped = CreateKeyValues("K98SniperScoped");
	new Handle:KvCallUndeployed = CreateKeyValues("CallUndeployed");
	new Handle:KvMG42Undeployed = CreateKeyValues("MG42Undeployed");
	new Handle:KvBarSemiAuto = CreateKeyValues("BarSemiAuto");
	new Handle:KvSTGSemiAuto = CreateKeyValues("STG44SemiAuto");
	new Handle:KvK98 = CreateKeyValues("K98");
	new Handle:KvRocket = CreateKeyValues("Rocket");
	new Handle:KvGrenade = CreateKeyValues("Grenade");
	
	new String:ConfigFile[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_Colt.cfg");
	
	if ( !FileToKeyValues(KvColt, ConfigFile) )
    {
        CloseHandle(KvColt);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvColt);
	new bool:sectionExists;
	sectionExists = KvGotoFirstSubKey(KvColt);
	if ( !sectionExists )
    {
        CloseHandle(KvColt);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	new String:filename[PLATFORM_MAX_PATH];
	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvColt, "enabled") );
        #endif
        if ( KvGetNum(KvColt, "enabled") )
        {
            KvGetString(KvColt, "primary", filename, sizeof(filename));
            ColtIndex[ColtIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvColt, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvColt);
    }
    
	CloseHandle(KvColt);

	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_P38.cfg");
	if ( !FileToKeyValues(KvP38, ConfigFile) )
    {
        CloseHandle(KvP38);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvP38);
	sectionExists = KvGotoFirstSubKey(KvP38);
	if ( !sectionExists )
    {
        CloseHandle(KvP38);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvP38, "enabled") );
        #endif
        if ( KvGetNum(KvP38, "enabled") )
        {
            KvGetString(KvP38, "primary", filename, sizeof(filename));
            P38Index[P38IndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvP38, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvP38);
    }
    
	CloseHandle(KvP38);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_C96.cfg");
	if ( !FileToKeyValues(KvC96, ConfigFile) )
    {
        CloseHandle(KvC96);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvC96);
	sectionExists = KvGotoFirstSubKey(KvC96);
	if ( !sectionExists )
    {
        CloseHandle(KvC96);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvC96, "enabled") );
        #endif
        if ( KvGetNum(KvC96, "enabled") )
        {
            KvGetString(KvC96, "primary", filename, sizeof(filename));
            C96Index[C96IndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvC96, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvC96);
    }
    
	CloseHandle(KvC96);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_Garand.cfg");
	if ( !FileToKeyValues(KvGarand, ConfigFile) )
    {
        CloseHandle(KvGarand);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section

	KvRewind(KvGarand);
	sectionExists = KvGotoFirstSubKey(KvGarand);
	if ( !sectionExists )
    {
        CloseHandle(KvGarand);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvGarand, "enabled") );
        #endif
        if ( KvGetNum(KvGarand, "enabled") )
        {
            KvGetString(KvGarand, "primary", filename, sizeof(filename));
            GarandIndex[GarandIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvGarand, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvGarand);
    }
    
	CloseHandle(KvGarand);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_M1carbine.cfg");
	if ( !FileToKeyValues(KvM1Carbine, ConfigFile) )
    {
        CloseHandle(KvM1Carbine);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvM1Carbine);
	sectionExists = KvGotoFirstSubKey(KvM1Carbine);
	if ( !sectionExists )
    {
        CloseHandle(KvM1Carbine);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvM1Carbine, "enabled") );
        #endif
        if ( KvGetNum(KvM1Carbine, "enabled") )
        {
            KvGetString(KvM1Carbine, "primary", filename, sizeof(filename));
            M1CarbineIndex[M1CarbineIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvM1Carbine, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvM1Carbine);
    }
    
	CloseHandle(KvM1Carbine);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_Springfield.cfg");
	if ( !FileToKeyValues(KvSpringfield, ConfigFile) )
    {
        CloseHandle(KvSpringfield);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvSpringfield);
	sectionExists = KvGotoFirstSubKey(KvSpringfield);
	if ( !sectionExists )
    {
        CloseHandle(KvSpringfield);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvSpringfield, "enabled") );
        #endif
        if ( KvGetNum(KvSpringfield, "enabled") )
        {
            KvGetString(KvSpringfield, "primary", filename, sizeof(filename));
            SpringfieldIndex[SpringfieldIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvSpringfield, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvSpringfield);
    }
    
	CloseHandle(KvSpringfield);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_K98Sniper.cfg");
	if ( !FileToKeyValues(KvK98Sniper, ConfigFile) )
    {
        CloseHandle(KvK98Sniper);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvK98Sniper);
	sectionExists = KvGotoFirstSubKey(KvK98Sniper);
	if ( !sectionExists )
    {
        CloseHandle(KvK98Sniper);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvK98Sniper, "enabled") );
        #endif
        if ( KvGetNum(KvK98Sniper, "enabled") )
        {
            KvGetString(KvK98Sniper, "primary", filename, sizeof(filename));
            K98SniperIndex[K98SniperIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvK98Sniper, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvK98Sniper);
    }
    
	CloseHandle(KvK98Sniper);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_Thompson.cfg");
	if ( !FileToKeyValues(KvThompson, ConfigFile) )
    {
        CloseHandle(KvThompson);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvThompson);
	sectionExists = KvGotoFirstSubKey(KvThompson);
	if ( !sectionExists )
    {
        CloseHandle(KvThompson);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvThompson, "enabled") );
        #endif
        if ( KvGetNum(KvThompson, "enabled") )
        {
            KvGetString(KvThompson, "primary", filename, sizeof(filename));
            ThompsonIndex[ThompsonIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvThompson, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvThompson);
    }
    
	CloseHandle(KvThompson);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_MP40.cfg");
	if ( !FileToKeyValues(KvMP40, ConfigFile) )
    {
        CloseHandle(KvMP40);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvMP40);
	sectionExists = KvGotoFirstSubKey(KvMP40);
	if ( !sectionExists )
    {
        CloseHandle(KvMP40);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvMP40, "enabled") );
        #endif
        if ( KvGetNum(KvMP40, "enabled") )
        {
            KvGetString(KvMP40, "primary", filename, sizeof(filename));
            MP40Index[MP40IndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvMP40, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvMP40);
    }
    
	CloseHandle(KvMP40);
	
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_STGAuto.cfg");
	if ( !FileToKeyValues(KvSTGAuto, ConfigFile) )
    {
        CloseHandle(KvSTGAuto);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvSTGAuto);
	sectionExists = KvGotoFirstSubKey(KvSTGAuto);
	if ( !sectionExists )
    {
        CloseHandle(KvSTGAuto);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvSTGAuto, "enabled") );
        #endif
        if ( KvGetNum(KvSTGAuto, "enabled") )
        {
            KvGetString(KvSTGAuto, "primary", filename, sizeof(filename));
            STGAutoIndex[STGAutoIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvSTGAuto, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvSTGAuto);
    }
    
	CloseHandle(KvSTGAuto);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_BarAuto.cfg");
	if ( !FileToKeyValues(KvBarAuto, ConfigFile) )
    {
        CloseHandle(KvBarAuto);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvBarAuto);
	sectionExists = KvGotoFirstSubKey(KvBarAuto);
	if ( !sectionExists )
    {
        CloseHandle(KvBarAuto);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvBarAuto, "enabled") );
        #endif
        if ( KvGetNum(KvBarAuto, "enabled") )
        {
            KvGetString(KvBarAuto, "primary", filename, sizeof(filename));
            BarAutoIndex[BarAutoIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvBarAuto, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvBarAuto);
    }
    
	CloseHandle(KvBarAuto);
	
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_Calldeployed.cfg");
	if ( !FileToKeyValues(KvCalldeployed, ConfigFile) )
    {
        CloseHandle(KvCalldeployed);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvCalldeployed);
	sectionExists = KvGotoFirstSubKey(KvCalldeployed);
	if ( !sectionExists )
    {
        CloseHandle(KvCalldeployed);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvCalldeployed, "enabled") );
        #endif
        if ( KvGetNum(KvCalldeployed, "enabled") )
        {
            KvGetString(KvCalldeployed, "primary", filename, sizeof(filename));
            CalldeployedIndex[CalldeployedIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvCalldeployed, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvCalldeployed);
    }
    
	CloseHandle(KvCalldeployed);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_MG42Deployed.cfg");
	if ( !FileToKeyValues(KvMG42Deployed, ConfigFile) )
    {
        CloseHandle(KvMG42Deployed);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvMG42Deployed);
	sectionExists = KvGotoFirstSubKey(KvMG42Deployed);
	if ( !sectionExists )
    {
        CloseHandle(KvMG42Deployed);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvMG42Deployed, "enabled") );
        #endif
        if ( KvGetNum(KvMG42Deployed, "enabled") )
        {
            KvGetString(KvMG42Deployed, "primary", filename, sizeof(filename));
            MG42DeployedIndex[MG42DeployedIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvMG42Deployed, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvMG42Deployed);
    }
    
	CloseHandle(KvMG42Deployed);
	
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_GarandIronSight.cfg");
	if ( !FileToKeyValues(KvGarandIronSight, ConfigFile) )
    {
        CloseHandle(KvGarandIronSight);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvGarandIronSight);
	sectionExists = KvGotoFirstSubKey(KvGarandIronSight);
	if ( !sectionExists )
    {
        CloseHandle(KvGarandIronSight);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvGarandIronSight, "enabled") );
        #endif
        if ( KvGetNum(KvGarandIronSight, "enabled") )
        {
            KvGetString(KvGarandIronSight, "primary", filename, sizeof(filename));
            GarandIronSightIndex[GarandIronSightIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvGarandIronSight, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvGarandIronSight);
    }
    
	CloseHandle(KvGarandIronSight);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_K98IronSight.cfg");
	if ( !FileToKeyValues(KvK98IronSight, ConfigFile) )
    {
        CloseHandle(KvK98IronSight);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvK98IronSight);
	sectionExists = KvGotoFirstSubKey(KvK98IronSight);
	if ( !sectionExists )
    {
        CloseHandle(KvK98IronSight);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvK98IronSight, "enabled") );
        #endif
        if ( KvGetNum(KvK98IronSight, "enabled") )
        {
            KvGetString(KvK98IronSight, "primary", filename, sizeof(filename));
            K98IronSightIndex[K98IronSightIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvK98IronSight, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvK98IronSight);
    }
    
	CloseHandle(KvK98IronSight);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_SpringfieldScoped.cfg");
	if ( !FileToKeyValues(KvSpringfieldScoped, ConfigFile) )
    {
        CloseHandle(KvSpringfieldScoped);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvSpringfieldScoped);
	sectionExists = KvGotoFirstSubKey(KvSpringfieldScoped);
	if ( !sectionExists )
    {
        CloseHandle(KvSpringfieldScoped);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvSpringfieldScoped, "enabled") );
        #endif
        if ( KvGetNum(KvSpringfieldScoped, "enabled") )
        {
            KvGetString(KvSpringfieldScoped, "primary", filename, sizeof(filename));
            SpringfieldScopedIndex[SpringfieldScopedIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvSpringfieldScoped, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvSpringfieldScoped);
    }
    
	CloseHandle(KvSpringfieldScoped);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_K98SniperScoped.cfg");
	if ( !FileToKeyValues(KvK98SniperScoped, ConfigFile) )
    {
        CloseHandle(KvK98SniperScoped);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvK98SniperScoped);
	sectionExists = KvGotoFirstSubKey(KvK98SniperScoped);
	if ( !sectionExists )
    {
        CloseHandle(KvK98SniperScoped);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }
	
	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvK98SniperScoped, "enabled") );
        #endif
        if ( KvGetNum(KvK98SniperScoped, "enabled") )
        {
            KvGetString(KvK98SniperScoped, "primary", filename, sizeof(filename));
            K98SniperScopedIndex[K98SniperScopedIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvK98SniperScoped, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvK98SniperScoped);
    }
    
	CloseHandle(KvK98SniperScoped);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_CallUndeployed.cfg");
	if ( !FileToKeyValues(KvCallUndeployed, ConfigFile) )
    {
        CloseHandle(KvCallUndeployed);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvCallUndeployed);
	sectionExists = KvGotoFirstSubKey(KvCallUndeployed);
	if ( !sectionExists )
    {
        CloseHandle(KvCallUndeployed);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvCallUndeployed, "enabled") );
        #endif
        if ( KvGetNum(KvCallUndeployed, "enabled") )
        {
            KvGetString(KvCallUndeployed, "primary", filename, sizeof(filename));
            CallUndeployedIndex[CallUndeployedIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvCallUndeployed, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvCallUndeployed);
    }
    
	CloseHandle(KvCallUndeployed);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_MG42Undeployed.cfg");
	if ( !FileToKeyValues(KvMG42Undeployed, ConfigFile) )
    {
        CloseHandle(KvMG42Undeployed);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvMG42Undeployed);
	sectionExists = KvGotoFirstSubKey(KvMG42Undeployed);
	if ( !sectionExists )
    {
        CloseHandle(KvMG42Undeployed);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors

	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvMG42Undeployed, "enabled") );
        #endif
        if ( KvGetNum(KvMG42Undeployed, "enabled") )
        {
            KvGetString(KvMG42Undeployed, "primary", filename, sizeof(filename));
            MG42UndeployedIndex[MG42UndeployedIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvMG42Undeployed, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvMG42Undeployed);
    }
    
	CloseHandle(KvMG42Undeployed);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_BarSemiAuto.cfg");
	if ( !FileToKeyValues(KvBarSemiAuto, ConfigFile) )
    {
        CloseHandle(KvBarSemiAuto);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvBarSemiAuto);
	sectionExists = KvGotoFirstSubKey(KvBarSemiAuto);
	if ( !sectionExists )
    {
        CloseHandle(KvBarSemiAuto);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvBarSemiAuto, "enabled") );
        #endif
        if ( KvGetNum(KvBarSemiAuto, "enabled") )
        {
            KvGetString(KvBarSemiAuto, "primary", filename, sizeof(filename));
            BarSemiAutoIndex[BarSemiAutoIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvBarSemiAuto, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvBarSemiAuto);
    }
    
	CloseHandle(KvBarSemiAuto);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_STGSemiAuto.cfg");
	if ( !FileToKeyValues(KvSTGSemiAuto, ConfigFile) )
    {
        CloseHandle(KvSTGSemiAuto);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

	// Find first color section
	KvRewind(KvSTGSemiAuto);
	sectionExists = KvGotoFirstSubKey(KvSTGSemiAuto);
	if ( !sectionExists )
    {
        CloseHandle(KvSTGSemiAuto);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

	// Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvSTGSemiAuto, "enabled") );
        #endif
        if ( KvGetNum(KvSTGSemiAuto, "enabled") )
        {
            KvGetString(KvSTGSemiAuto, "primary", filename, sizeof(filename));
            STGSemiAutoIndex[STGSemiAutoIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvSTGSemiAuto, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvSTGSemiAuto);
    }
    
	CloseHandle(KvSTGSemiAuto);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_K98.cfg");
	if ( !FileToKeyValues(KvK98, ConfigFile) )
    {
        CloseHandle(KvK98);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

    // Find first color section
	KvRewind(KvK98);
	sectionExists = KvGotoFirstSubKey(KvK98);
	if ( !sectionExists )
	{
        CloseHandle(KvK98);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

    // Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvK98, "enabled") );
        #endif
        if ( KvGetNum(KvK98, "enabled") )
        {
            KvGetString(KvK98, "primary", filename, sizeof(filename));
            K98Index[K98IndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvK98, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvK98);
    }
    
	CloseHandle(KvK98);
	
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_Rocket.cfg");
	if ( !FileToKeyValues(KvRocket, ConfigFile) )
    {
        CloseHandle(KvRocket);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

    // Find first color section
	KvRewind(KvRocket);
	sectionExists = KvGotoFirstSubKey(KvRocket);
	if ( !sectionExists )
	{
        CloseHandle(KvRocket);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

    // Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvRocket, "enabled") );
        #endif
        if ( KvGetNum(KvRocket, "enabled") )
        {
            KvGetString(KvRocket, "primary", filename, sizeof(filename));
            RocketIndex[RocketIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvRocket, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvRocket);
    }
    
	CloseHandle(KvRocket);	

	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/dod_paintball/dod_paintball_Grenade.cfg");
	if ( !FileToKeyValues(KvGrenade, ConfigFile) )
    {
        CloseHandle(KvGrenade);
        LogError("[ERROR] paintball can not convert file to keyvalues: %s", ConfigFile);
        return;
    }

    // Find first color section
	KvRewind(KvGrenade);
	sectionExists = KvGotoFirstSubKey(KvGrenade);
	if ( !sectionExists )
	{
        CloseHandle(KvGrenade);
        LogError("[ERROR] paintball can not find first keyvalues subkey in file: %s", ConfigFile);
        return;
    }

    // Load all colors
	while ( sectionExists )
    {
        #if defined PAINTBALL_DEBUG
            LogError("[PAINTBALL_DEBUG] OnMapStart :: check if color enabled : %i", KvGetNum(KvGrenade, "enabled") );
        #endif
        if ( KvGetNum(KvGrenade, "enabled") )
        {
            KvGetString(KvGrenade, "primary", filename, sizeof(filename));
            GrenadeIndex[GrenadeIndexCount++] = precachePaintballDecal(filename);
            KvGetString(KvGrenade, "secondary", filename, sizeof(filename));
            precachePaintballDecal(filename);
        }

        sectionExists = KvGotoNextKey(KvGrenade);
    }
    
	CloseHandle(KvGrenade);	
	
	g_Explosion = PrecacheModel("sprites/fire.vmt");
}

precachePaintballDecal(const String:filename[])
{
    #if defined PAINTBALL_DEBUG
        LogError("[PAINTBALL_DEBUG] precachePaintballDecal(%s)", filename);
    #endif
    new String:tmpPath[PLATFORM_MAX_PATH];
    new result = 0;
    result = PrecacheDecal(filename, true);
    Format(tmpPath,sizeof(tmpPath),"materials/%s",filename);
    AddFileToDownloadsTable(tmpPath);
    #if defined PAINTBALL_DEBUG
        LogError("[PAINTBALL_DEBUG] precachePaintballDecal :: return %i", result);
    #endif
    return result;
}

public Action:Event_DodStatsWeaponAttack(Handle:event, const String:weaponName[], bool:dontBroadcast)
{
    if ( g_clientsPaintballEnabledTotal )
    {
		new client;
		client = GetClientOfUserId(GetEventInt(event, "attacker"));

	
		decl Float:vecPos[3], Float:vecAng[3], Float:vecOrigin[3];
		GetClientEyePosition(client, vecOrigin);
		GetClientEyeAngles(client, vecAng);
		new Handle:trace = TR_TraceRayFilterEx(vecOrigin, vecAng, MASK_SHOT, RayType_Infinite, TraceEntityFilterPlayer);
	
		new weaponid = GetEventInt(event, "weapon");

	
		if(TR_DidHit(trace)) 
		{
			//3  Colt
			if (weaponid == 3)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
		
			TE_SetupWorldDecal(vecPos, ColtIndex[GetRandomInt(0, ColtIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//4  P38		
			if (weaponid == 4)
			{
			TR_GetEndPosition(vecPos, trace);	
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, P38Index[GetRandomInt(0, P38IndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//5  C96		
			if (weaponid == 5)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, C96Index[GetRandomInt(0, C96IndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//6  Garand		
			if (weaponid == 6)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, GarandIndex[GetRandomInt(0, GarandIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//7  M1 Carbine	
			if (weaponid == 7)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, M1CarbineIndex[GetRandomInt(0, M1CarbineIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);	
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//8  K98		
			if (weaponid == 8)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, K98Index[GetRandomInt(0, K98IndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//9  Springfield		
			if (weaponid == 9)
			{
			TR_GetEndPosition(vecPos, trace);	
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, SpringfieldIndex[GetRandomInt(0, SpringfieldIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//10  K98 Sniper		
			if (weaponid == 10)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, K98SniperIndex[GetRandomInt(0, K98SniperIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//11  Thompson		
			if (weaponid == 11)
			{
			TR_GetEndPosition(vecPos, trace);	
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, ThompsonIndex[GetRandomInt(0, ThompsonIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//12  Mp40	
			if (weaponid == 12)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, MP40Index[GetRandomInt(0, MP40IndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//13  Stg 44 Auto		
			if (weaponid == 13)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, STGAutoIndex[GetRandomInt(0, STGAutoIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//14  Bar	Auto
			if (weaponid == 14)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, BarAutoIndex[GetRandomInt(0, BarAutoIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//15  30cal -deployed		
			if (weaponid == 15)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, CalldeployedIndex[GetRandomInt(0, CalldeployedIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//16  MG42 -deployed	
			if (weaponid == 16)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, MG42DeployedIndex[GetRandomInt(0, MG42DeployedIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//31  Garand -iron sight		
			if (weaponid == 31)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, GarandIronSightIndex[GetRandomInt(0, GarandIronSightIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//32  K98 -iron sight		
			if (weaponid == 32)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, K98IronSightIndex[GetRandomInt(0, K98IronSightIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//33  Springfield -scoped		
			if (weaponid == 33)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, SpringfieldScopedIndex[GetRandomInt(0, SpringfieldScopedIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//34  K98 Sniper -scoped		
			if (weaponid == 34)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, K98SniperScopedIndex[GetRandomInt(0, K98SniperScopedIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//35  30cal -undeployed
			if (weaponid == 35)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, CallUndeployedIndex[GetRandomInt(0, CallUndeployedIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//36  MG42 -undeployed		
			if (weaponid == 36)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, MG42UndeployedIndex[GetRandomInt(0, MG42UndeployedIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//37 Bar- Semi Auto		
			if (weaponid == 37)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, BarSemiAutoIndex[GetRandomInt(0, BarSemiAutoIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}
			
			//38 Stg44 -Semi Auto
			if (weaponid == 38)
			{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
			
			TE_SetupWorldDecal(vecPos, STGSemiAutoIndex[GetRandomInt(0, STGSemiAutoIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
			
			if( GetConVarBool(g_Explosive) )
			{		
			TE_SetupExplosion(vecPos, g_Explosion, 10.0, 1, 0, 600, 5000);
			TE_SendToAll();
			}
			}		
		}		
    }
}

public Action:DetonateRocket(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		decl Float:vecPos[3], Float:vecAng[3], Float:vecOrigin[3];
		GetClientEyePosition(client, vecOrigin);
		GetClientEyeAngles(client, vecAng);
		new Handle:trace = TR_TraceRayFilterEx(vecOrigin, vecAng, MASK_SHOT, RayType_Infinite, TraceEntityFilterPlayer);
	
		if(TR_DidHit(trace)) 
		{
			TR_GetEndPosition(vecPos, trace);
			
			CloseHandle(trace);
		
		
			TE_SetupWorldDecal(vecPos, RocketIndex[GetRandomInt(0, RocketIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
		}
	}
}

TE_SetupWorldDecal(const Float:vecOrigin[3], index)
{    
    TE_Start("World Decal");
    TE_WriteVector("m_vecOrigin",vecOrigin);
    TE_WriteNum("m_nIndex",index);
}

public bool:TraceEntityFilterPlayer(entity, contentsMask, any:client) 
{
	return entity>MaxClients;
}

public Action:MenuPaintball(client, args)
{
    new Handle:menu = CreateMenu(MenuHandlerPaintball);
    decl String:buffer[64];

    Format(buffer, sizeof(buffer), "%t", "Paintball settings");
    SetMenuTitle(menu, buffer);

    Format(buffer, sizeof(buffer), "%t %t", "Show paintball impacts", 
        g_clientPrefs[client] ? "Selected" : "NotSelected");
    AddMenuItem(menu, "Show paintball impacts", buffer);

    SetMenuExitButton(menu, true);
    DisplayMenu(menu, client, 20);
    return Plugin_Handled;
}

public MenuHandlerPaintball(Handle:menu, MenuAction:action, client, item)
{
    if(action == MenuAction_Select) 
    {
        if(item == 0)
        {
            g_clientPrefs[client] = g_clientPrefs[client] ? 0 : 1;
            decl String:buffer[5];
            IntToString(g_clientPrefs[client], buffer, 5);
            SetClientCookie(client, g_Cookie_Pref, buffer);
            recalculateClients(0);
            MenuPaintball(client, 0);
        }
    } 
    else if(action == MenuAction_End)
    {
        CloseHandle(menu);
    }
}

public OnClientPutInServer(client)
{
    g_clientPrefs[client] = GetConVarInt(g_Cvar_PrefDefault);

    if(!IsFakeClient(client))
    {   
        if (AreClientCookiesCached(client))
        {
            loadClientCookies(client);
        } 
    }
}

public OnClientCookiesCached(client)
{
    if(IsClientInGame(client) && !IsFakeClient(client))
    {
        loadClientCookies(client);  
    }
}

loadClientCookies(client)
{
    decl String:buffer[5];
    GetClientCookie(client, g_Cookie_Pref, buffer, 5);
    if ( !StrEqual(buffer, "") )
    {
        g_clientPrefs[client] = StringToInt(buffer);
    }
    recalculateClients(0);
}

recalculateClients(disconnectedClient)
{
    g_clientsPaintballEnabledTotal = 0;
    for (new i=1; i<=MaxClients; i++)
    {
        if ( IsClientInGame(i) && g_clientPrefs[i] && ( i != disconnectedClient ) )
        {
            g_clientsPaintballEnabled[g_clientsPaintballEnabledTotal++] = i;
        }
    }
}

public OnClientDisconnect(client)
{
    recalculateClients(client);
}

public OnEntityCreated(iEntity, const String:szEntityName[])
{
	for (new i = 0; i < sizeof(g_szGrenadeTypes); i++)
	{
		if (StrEqual(szEntityName, g_szGrenadeTypes[i]))
		{
			SDKHook(iEntity, SDKHook_StartTouch,OnStartTouch);
			
			break;
		}
	}
}

public OnStartTouch(iEntity , other)
{
	decl Float:vecPos[3];
	
	if ((GetEntProp(other, Prop_Send, "m_nSolidType") != 0) && ((GetEntProp(other, Prop_Send, "m_usSolidFlags") & 8) == 0))
	{
		decl String:Classname[256];
		GetEdictClassname(iEntity, Classname, sizeof(Classname));
	
		if(StrEqual(Classname, "grenade_smoke_us" , false) || StrEqual(Classname, "grenade_smoke_ger", false) || StrEqual(Classname, "grenade_frag_us", false) || StrEqual(Classname, "grenade_frag_ger", false) || StrEqual(Classname, "grenade_riflegren_us", false) || StrEqual(Classname, "grenade_riflegren_ger", false))
		{
			TE_SetupWorldDecal(vecPos, GrenadeIndex[GetRandomInt(0, GrenadeIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);	
		}
			else if(StrEqual(Classname, "rocket_bazooka", false) || StrEqual(Classname, "rocket_pschreck", false))
		{
			TE_SetupWorldDecal(vecPos, RocketIndex[GetRandomInt(0, RocketIndexCount - 1)]);
			TE_Send(g_clientsPaintballEnabled, g_clientsPaintballEnabledTotal);
		}
	}
}